hungph/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/hello-world', 'HelloWorldController@show');

Route::resource('users', 'UserController');
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

hungph/app/Models/Classroom.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Classroom extends Model
{
    /**
     * Get the users for the classroom.
     */
    public function users()
    {
        return $this->hasMany('App\Models\Users');
    }

    /**
     * Get all classroom in table Classrooms
     *
     * @param 
     * @return $classrooms
     */
    public function getClassroom()
    {
        return Classroom::pluck('name', 'id');
    }
}

hungph/app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Http\Request;
use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Hash;

class User extends Authenticatable
{
    use Notifiable;
    use SoftDeletes;
    protected $table = 'users';
    const ROLE_ADMIN = 1;
    const ROLE_STAFF = 2;
    public static $role = [
        self::ROLE_ADMIN => "Quản trị viên",
        self::ROLE_STAFF => "Nhân viên"
    ];

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = ['deleted_at'];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'mail_address', 'password', 'phone', 'address', 'role', 'classroom_id',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * Get the classroom for the user.
     */
    public function classroom()
    {
        return $this->belongsTo('App\Models\Classroom');
    }

    /**
     * Scope a query to search users follow mail address.
     *
     * @return  \Illuminate\Database\Eloquent\Builder
     */
    public function scopeMailAddress($query, $mailAddress)
    {
        return $query->where('mail_address', 'LIKE', '%' . $mailAddress . '%');
    }

    /**
     * Scope a query to search users follow name.
     *
     * @return  \Illuminate\Database\Eloquent\Builder
     */
    public function scopeName($query, $name)
    {
        return $query->where('name', 'LIKE', '%' . $name . '%');
    }

    /**
     * Scope a query to search users follow address.
     *
     * @return  \Illuminate\Database\Eloquent\Builder
     */
    public function scopeAddress($query, $address)
    {
        return $query->where('address', 'LIKE', '%' . $address . '%');
    }

    /**
     * Scope a query to search users follow classroom.
     *
     * @return  \Illuminate\Database\Eloquent\Builder
     */
    public function scopeClassroom($query, $classroomId)
    {
        return $query->with('classroom')->where('classroom_id', $classroomId);
    }

    /**
     * Scope a query to search users follow phone.
     *
     * @return  \Illuminate\Database\Eloquent\Builder
     */
    public function scopePhone($query, $phone)
    {
        return $query->where('phone', $phone);
    }

    /**
     * Create new user in table Users 
     *
     * @param array $data
     * @return 
     */
    public function createUser(array $data)
    {
        $data['password'] = Hash::make($data['password']);
        return User::create($data);
    }

    /**
     * Get all user in table Users and find user with condition
     *
     * @param 
     * @return $users
     */
    public function getUser(array $data)
    {
        $builder = User::orderBy('mail_address', 'ASC');    

        if (isset($data['mail_address']) && $data['mail_address'] != '') {
            $builder->mailAddress($data['mail_address']);
        }

        if (isset($data['name']) && $data['name'] != '') {
            $builder->name($data['name']);
        }
        if (isset($data['address']) && $data['address'] != '') {
            $builder->address($data['address']);
        }

        if (isset($data['classroom_id']) && $data['classroom_id'] != '') {
            $builder->classroom($data['classroom_id']);
        }

        if (isset($data['phone']) && $data['phone'] != '') {
            $builder->phone($data['phone']);
        }

        return $builder->paginate(20);
    }
}

hungph/app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

hungph/app/Http/Controllers/HelloWorldController.php
<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;

class HelloWorldController extends Controller
{
    /**
     * Show the view for the given user.
     *
     * @param null
     * @return view
     */
    public function show()
    {
        return view('hello_world.show');
    }
}

hungph/app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

hungph/app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Requests\CreateUserRequest;
use App\Models\User;
use App\Models\Classroom;
use App\Events\CreatedUser;

use Helper;

class UserController extends Controller
{

    /**
     * The user implementation.
     *
     * @var User
     */
    protected $user;

    protected $classroom;

    /**
     * Create a new controller instance.
     *
     * @param User $users
     * @return void
     */
    public function __construct(User $user, Classroom $classroom)
    {
        $this->user = $user;
        $this->middleware([
            'auth', 
            'classable',
        ]);
        $this->classroom = $classroom;
    }

    /**
     * Show all users, return view a list of users
     *
     * @param 
     * @return view users.index
     */
    public function index(Request $request) 
    {
        $classrooms = $this->classroom->getClassroom();

        $this->authorize('staff');
        $data = $request->all();
        $users = $this->user->getUser($data);
        return view('users.index', compact(
            'users',
            'classrooms'
        ));
    }

    /**
     * Redirect to view create an user
     *
     * @param 
     * @return view users.create
     */
    public function create() 
    {
        $classrooms = $this->classroom->getClassroom();

        $this->authorize('admin');

    	return view('users.create', compact(
            'classrooms'
        ));
    }

    /**
     * Store user from request and 
     *
     * @param Request $request
     * @return view users.index
     */
    public function store(CreateUserRequest $request)
    {
        $data = $request->all();
        $user= $this->user->createUser($data);
        event(new CreatedUser($user));
        flash('Thêm mới người dùng thành công')->success();
        return redirect()->route('users.index');
    }
}

hungph/resources/views/hello_world/show.blade.php
<!doctype html>
<!-- Website template by freewebsitetemplates.com -->
<html>
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>Frozen Yogurt Shop</title>
	<link rel="stylesheet" href="css/style.css" type="text/css">
	<link rel="stylesheet" type="text/css" href="css/mobile.css">
	<script src="js/mobile.js" type="text/javascript"></script>
</head>
<body>
	<div id="page">
		<div id="header">
			<div>
				<a href="index.html" class="logo"><img src="images/logo.png" alt=""></a>
				<ul id="navigation">
					<li class="selected">
						<a href="index.html">Home</a>
					</li>
					<li class="menu">
						<a href="about.html">About</a>
						<ul class="primary">
							<li>
								<a href="product.html">Product</a>
							</li>
						</ul>
					</li>
					<li class="menu">
						<a href="blog.html">Blog</a>
						<ul class="secondary">
							<li>
								<a href="singlepost.html">Single post</a>
							</li>
						</ul>
					</li>
					<li>
						<a href="contact.html">Contact</a>
					</li>
				</ul>
			</div>
		</div>
		<div id="body" class="home">
			<div class="header">
				<img src="images/bg-home.jpg" alt="">
				<div>
					<a href="product.html">Freeze Delight</a>
				</div>
			</div>
			<div class="body">
				<div>
					<div>
						<h1>NEW PRODUCT</h1>
						<h2>The Twist of Healthy Yogurt</h2>
						<p>This website template has been designed by freewebsitetemplates.com for you, for free. You can replace all this text with your own text.</p>
					</div>
					<img src="images/yogurt.jpg" alt="">
				</div>
			</div>
			<div class="footer">
				<div>
					<ul>
						<li>
							<a href="product.html" class="product"></a>
							<h1>PRODUCTS</h1>
						</li>
						<li>
							<a href="about.html" class="about"></a>
							<h1>OUR STORY</h1>
						</li>
						<li>
							<a href="product.html" class="flavor"></a>
							<h1>FLAVORS</h1>
						</li>
						<li>
							<a href="contact.html" class="contact"></a>
							<h1>OUR LOCATION</h1>
						</li>
					</ul>
				</div>
			</div>
		</div>
		<div id="footer">
			<div>
				<div class="connect">
					<a href="http://freewebsitetemplates.com/go/facebook/" class="facebook">facebook</a>
					<a href="http://freewebsitetemplates.com/go/twitter/" class="twitter">twitter</a>
					<a href="http://freewebsitetemplates.com/go/googleplus/" class="googleplus">googleplus</a>
					<a href="http://pinterest.com/fwtemplates/" class="pinterest">pinterest</a>
				</div>
				<p>&copy; 2023 Freeeze. All Rights Reserved.</p>
			</div>
		</div>
	</div>
</body>
</html>

hungph/resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Trang chủ</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success">
                            {{ session('status') }}
                        </div>
                    @endif

                    Bạn đã đăng nhập!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

hungph/resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Raleway:300,400,600" rel="stylesheet" type="text/css">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light navbar-laravel">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li><a class="nav-link" href="{{ route('login') }}">{{ __('Đăng nhập') }}</a></li>
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

hungph/resources/views/layouts/default.blade.php
<html>
    @include('layouts.head')
    <body>
        <div class="container">
            @include('layouts.header')
            @yield('content')
        </div>

        @include('layouts.footer')
    </body>
</html>

hungph/resources/views/layouts/footer.blade.php
<div class="panel panel-default">
    <div class="panel-body text-center"> PHP training by LIFETIME technologies </div>
</div>

hungph/resources/views/layouts/head.blade.php
<head>
    <title>@yield('title')</title>
    {{-- css and js --}}
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
</head>

hungph/resources/views/layouts/header.blade.php
@section('header')
    <h1> @yield('title') </h1>

    <li class="nav-item dropdown">
	    <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
	        {{ Auth::user()->name }} <span class="caret"></span>
	    </a>

	    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
	        <a class="dropdown-item" href="{{ route('logout') }}"
	           onclick="event.preventDefault();
	                         document.getElementById('logout-form').submit();">
	            {{ __('Đăng xuất') }}
	        </a>

	        <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
	            @csrf
	        </form>
	    </div>
	</li>
@show

hungph/resources/views/users/create.blade.php
@extends('layouts.default')

@section('title', 'Thêm mới người dùng')

@section('header')
    <div class="row">
        @parent
        <p> Đây là trang đăng ký người dùng </p> 
    </div>
@endsection

@section('content')
    <div class="row">
        <div class="col-md-6">
            <form action="{{ route('users.store')}}" method="post" id="fileForm" role="form">
            <input type="hidden" name="_token" value="{{ csrf_token() }}">
            <fieldset><legend class="text-center">Nhập thông tin để đăng ký <span class="req"><small> bắt buộc *</small></span></legend>
            <div class="form-group @if($errors->has('mail_address')) alert alert-danger @endif">
                <label for="email"><span class="req">* </span> Địa chỉ email: </label> 
                    <input class="form-control" type="text" name="mail_address" id = "email" />  
                @if($errors->has('mail_address'))
                    {{ $errors->first('mail_address') }}
                @endif
            </div>

            <div class="form-group {{ $errors->has('password') ? 'alert alert-danger' : '' }}">
                <label for="password"><span class="req">* </span> Mật khẩu: </label>
                    <input name="password" type="password" class="form-control" id="pass1" /> </p>
                @if($errors->has('password'))
                    {{ $errors->first('password') }}
                @endif
            </div>

            <div class="form-group @if($errors->has('password_confirmation')) {{'alert alert-danger'}} @endif">
                <label for="password"><span class="req">* </span> Mật khẩu xác nhận: </label>
                    <input name="password_confirmation" type="password" class="form-control"/>
                        <span id="confirmMessage" class="confirmMessage"></span>
                    @if($errors->has('password_confirmation'))
                        {{ $errors->first('password_confirmation') }}
                    @endif
            </div>

            <div class="form-group @if($errors->has('name')) {{'alert alert-danger'}} @endif">     
                <label for="name"><span class="req">* </span> Tên: </label>
                    <input class="form-control" type="text" name="name" id = "txt"/> 
                @if($errors->has('name'))
                    {{ $errors->first('name') }}
                @endif
            </div>

            <div class="form-group @if($errors->has('address')) {{'alert alert-danger'}} @endif">
                <label for="address"><span class="req">* </span> Địa chỉ: </label> 
                    <input class="form-control" type="text" name="address" id = "txt"  placeholder="" />
                @if($errors->has('address'))
                    {{ $errors->first('address') }}
                @endif  
            </div>

            <div class="form-group @if($errors->has('phone')) {{'alert alert-danger'}} @endif">     
                <label for="phone"><span class="req">* </span> Số điện thoại: </label>
                    <input class="form-control" type="text" name="phone" id = "txt" /> 
                @if($errors->has('phone'))
                    {{ $errors->first('phone') }}
                @endif
            </div>

            <div class="form-group">
                <label for="role"><span class="req">* </span> Vai trò người dùng: </label>
                <select class="form-control" id="role" name="role">
                    @foreach (App\Models\User::$role as $key => $role)
                        <option value="{{ $key }}"> {{ $role }} </option>
                    @endforeach
                </select>
            </div>

            <div class="form-group">
                <label for="classroom"><span class="req">* </span> Lớp người dùng: </label>
                <select class="form-control" id="classroom" name="classroom_id">
                    <option></option>
                    @foreach ($classrooms as $id => $name)
                        <option value="{{ $id }}"> {{ $name }} </option>
                    @endforeach
                </select>
            </div>

            <div class="form-group">
                <input class="btn btn-success" type="submit" name="submit_reg" value="Đăng ký">
            </div>

            </fieldset>
            
            </form><!-- ends register form -->
        </div><!-- ends col-6 -->
    </div>
@endsection

hungph/resources/views/users/index.blade.php
@extends('layouts.default')

@section('title', 'Danh sách người dùng')

@section('header')
    <div class="row">
        @parent
        <p> Đây là trang danh sách người dùng </p> 
    </div>

@endsection

@section('content')
    <div class="row">
        <h2>Tìm kiếm người dùng</h2>
        <form method="get" action="{{ route('users.index') }}">
            <input type="hidden" name="_token" value="{{ csrf_token() }}">
            <div class="form-group">
                <label>Địa chỉ email</label>
                <input type="mail_address" class="form-control" name="mail_address" placeholder="Nhập địa chỉ email">
            </div>

            <div class="form-group">
                <label>Tên</label>
                <input type="name" class="form-control" name="name" placeholder="Nhập tên">
            </div>

            <div class="form-group">
                <label>Địa chỉ</label>
                <input type="address" class="form-control" name="address" placeholder="Nhập địa chỉ">
            </div>

            <div class="form-group">
                <label>Số điện thoại</label>
                <input type="phone" class="form-control" name="phone" placeholder="Nhập số điện thoại">
            </div>

            <div class="form-group">
                <label>Lớp người dùng</label>
                <select class="form-control" id="classroom" name="classroom_id">
                    <option></option>
                    @foreach ($classrooms as $id => $name)
                        <option value="{{ $id }}"> {{ $name }} </option>
                    @endforeach
                </select>
            </div>

            <div class="form-group">
                <input class="btn btn-info" type="submit" name="submit" value="Tìm kiếm">
            </div>
        </form>
    </div>
    <div class="row">
        <h2>Danh sách người sử dụng</h2>  
        @can('admin')
            <a href=" {{ route('users.create') }}" class="btn btn-info"> Đăng kí </a> 
        @endcan  
        @include('flash::message')
            <div class="table-responsive">   
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th class="text-center"> Số thứ tự </th>
                        <th class="text-center"> Địa chỉ email </th>
                        <th class="text-center"> Tên </th>
                        <th class="text-center"> Địa chỉ </th>
                        <th class="text-center"> Số điện thoại </th>
                        <th class="text-center"> Vai trò </th>
                        <th class="text-center"> Lớp người dùng </th>
                    </tr>
                </thead>
                <tbody>
                    @foreach($users as $user)
                    <tr>
                        <td class="text-left">{{ (($users->currentPage() - 1 ) * $users->perPage() ) + $loop->iteration }}</td>
                        <td class="text-left">{{ $user->mail_address }}</td>
                        <td class="text-left">{{ Helper::toUpperCase($user->name) }}</td>
                        <td class="text-left">{{ $user->address }}</td>
                        <td class="text-left">{{ $user->phone }}</td>
                        <td class="text-left">
                            {{ App\Models\User::$role[$user->role] }}
                        </td>
                        <td class="text-left">{{ $user->classroom->name }}</td>
                    </tr>
                    @endforeach
                </tbody>
            </table>
            {{ $users->links() }}
    </div>
@endsection